require "import"
import "android.widget.*"
import "android.view.*"
import "android.content.*"
import "java.io.*"
import "android.graphics.Bitmap"
import "android.graphics.BitmapFactory"
import "android.net.Uri"
import "java.io.FileOutputStream"
import "android.graphics.Matrix"
import "android.graphics.RectF"
import "android.view.ScaleGestureDetector"

-- 常量定义
wjj = "/storage/emulated/0/DCIM/Screenshots/"
wjm = os.date("%Y%m%d_%H%M%S")..".jpg"

-- 截图函数
task(500,function()
service.getScreenShot(node,{
onScreenCaptureDone = function(bitmap)
local dir = File(wjj)
if not dir.exists() then
dir.mkdirs()
end
local file = File(wjj, wjm)
bitmap.compress(Bitmap.CompressFormat.PNG, 100, FileOutputStream(file))

-- 通知系统更新媒体库
local intent = Intent(Intent.ACTION_MEDIA_SCANNER_SCAN_FILE)
intent.setData(Uri.fromFile(file))
service.sendBroadcast(intent)

return file
end
})
end)

-- 截图预览函数（仅保留双指缩放和拖动）
function jtjm()
-- 创建布局
local layout = {
LinearLayout,
layout_width = "fill",
layout_height = "fill",
{
ImageView,
id = "imageView",
layout_width = "fill",
layout_height = "100%h",
background="#ff000000",
scaleType = "matrix",
},
}

-- 加载布局
local id = {}
local view = loadlayout(layout, id)
local imageView = id.imageView

-- 加载图片
local bitmap
pcall(function()
bitmap = BitmapFactory.decodeFile(wjj..wjm)
end)

if not bitmap then
Toast.makeText(service, "图片加载失败", Toast.LENGTH_SHORT).show()
return
end

imageView.setImageBitmap(bitmap)

-- 初始化矩阵参数
local matrix = Matrix()
local savedMatrix = Matrix()
local currentScale = 1.0
local minScale = 1.0
local maxScale = 15.0
local lastX, lastY = 0, 0
local isDragging = false

-- 初始缩放设置
local function setupInitialScale()
local imgWidth = bitmap.getWidth()
local imgHeight = bitmap.getHeight()
local viewWidth = imageView.getWidth()
local viewHeight = imageView.getHeight()

if imgWidth > 0 and imgHeight > 0 then
local scale = math.min(viewWidth/imgWidth, viewHeight/imgHeight)
currentScale = scale * 1.1 -- 初始放大10%

matrix.setScale(currentScale, currentScale)
matrix.postTranslate(
(viewWidth - imgWidth * currentScale)/2,
(viewHeight - imgHeight * currentScale)/2
)
imageView.setImageMatrix(matrix)
end
end

-- 边界限制
local function limitTranslate()
local rect = RectF(0, 0, bitmap.getWidth(), bitmap.getHeight())
matrix.mapRect(rect)

local viewWidth = imageView.getWidth()
local viewHeight = imageView.getHeight()

if rect.width() < viewWidth then
local dx = (viewWidth - rect.width())/2 - rect.left
matrix.postTranslate(dx, 0)
end

if rect.height() < viewHeight then
local dy = (viewHeight - rect.height())/2 - rect.top
matrix.postTranslate(0, dy)
end
end

-- 缩放手势检测器
local scaleGestureDetector = ScaleGestureDetector(service, {
onScale = function(detector)
local scaleFactor = detector.getScaleFactor()
scaleFactor = math.max(0.8, math.min(scaleFactor, 1.2))
currentScale = currentScale * scaleFactor
currentScale = math.max(minScale, math.min(currentScale, maxScale))

local focusX = detector.getFocusX()
local focusY = detector.getFocusY()
matrix.postScale(scaleFactor, scaleFactor, focusX, focusY)
imageView.setImageMatrix(matrix)
return true
end,

onScaleBegin = function(detector)
savedMatrix.set(matrix)
return true
end,

onScaleEnd = function(detector)
limitTranslate()
imageView.setImageMatrix(matrix)
end
})

-- 触摸事件处理（仅处理拖动和缩放）
imageView.setOnTouchListener({
onTouch = function(v, event)
scaleGestureDetector.onTouchEvent(event)

local action = event.getAction()
local x = event.getX()
local y = event.getY()

if action == MotionEvent.ACTION_DOWN then
lastX = x
lastY = y
isDragging = true
savedMatrix.set(matrix)
elseif action == MotionEvent.ACTION_MOVE then
if isDragging and event.getPointerCount() == 1 then
local dx = x - lastX
local dy = y - lastY
matrix.postTranslate(dx, dy)
imageView.setImageMatrix(matrix)
lastX = x
lastY = y
end
elseif action == MotionEvent.ACTION_UP or action == MotionEvent.ACTION_CANCEL then
isDragging = false
limitTranslate()
imageView.setImageMatrix(matrix)
end

return true
end
})

-- 初始缩放适配
imageView.post(function()
setupInitialScale()
end)

-- 创建对话框
local dlg = LuaDialog(service)
dlg.setView(view)
dlg.setCanceledOnTouchOutside(true)
dlg.setOnDismissListener({
onDismiss = function()
pcall(function() os.remove(wjj..wjm) end)
end
})
dlg.show()
end

task(600, jtjm)
return true